/* Zadatak 4:

*/

#include <stdio.h>

/* ========================================================================= */

    /* Funkcija minmid. */
    /* Varijabilni (izlazni) argumenti su pokazivaci p_xmin, p_ymin. */

void minmid(int n, double x[], double y[], double *p_xmin, double *p_ymin)
{
    int i, j, nm1 = n - 1;
    double x_mid, y_mid;    /* Koordinate polovista. */
    double x_min, y_min;    /* Koordinate najmanjeg polovista. */

        /* Inicijalizacija najmanjeg polovista na poloviste
           PRVE duzine A_0 A_1 (koristimo n >= 2). */
    x_min = (x[0] + x[1]) / 2;
    y_min = (y[0] + y[1]) / 2;

        /* Dvije petlje, po svim parovima tocaka A_i, A_j, uz i < j. */
    for (i = 0; i < nm1; ++i)
        for (j = i + 1; j < n; ++j) {

                /* Poloviste duzine A_i A_j. */
            x_mid = (x[i] + x[j]) / 2;
            y_mid = (y[i] + y[j]) / 2;

                /* Provjera minimalnosti po zadanom uredjaju. */
            if (y_mid < y_min || (y_mid == y_min && x_mid < x_min)) {

                    /* Popravi najmanje poloviste. */
                x_min = x_mid;
                y_min = y_mid;
            }
    }

        /* Vrati koordinate najmanjeg polovista (x_min, y_min)
           kroz varijabilne argumente. */
    *p_xmin = x_min;
    *p_ymin = y_min;

    return;
}

/* ========================================================================= */

    /* Glavni program za demo. */

int main(void)
{
        /* Broj tocaka. */
    int n = 10;

        /* Polja x i y s koordinatama tocaka. */
    double x[10] = {
      1.0, 2.0, 3.0, 3.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0 };
    double y[10] = {
      3.0, 3.0, 3.0, 2.0, 1.0, 3.0, 3.0, 3.0, 3.0, 3.0 };

    double x_min, y_min;

    minmid(n, x, y, &x_min, &y_min);
    printf("Najmanje poloviste = (%g, %g)\n", x_min, y_min);

    return 0;
}
